﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.WebUI.UltraWebGrid;
using System.Globalization;
using System.Data.SqlClient;


namespace UltraWebGrid1
{
    public partial class ProjectPlanning : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                PopulatePage(10035, "169");                
            }
        }

        private void PopulatePage(int projId, string dept)
        {
            String setVal = string.Empty;
            string dd = string.Empty;    

            DataSet projectData = GetProjectPlanningData(projId, dept);
            PopulateForecast(projectData);
        }


        private DataSet GetProjectPlanningData(int projectID, string dept)
        {
            //SqlConnection cn = new SqlConnection("Data Source=PY1DBMAPd01;Integrated Security=True;Initial Catalog=DMD_MGMT");
            //SqlCommand cmd = new SqlCommand("NPP_GetProjectPlanningData_ToDelete", cn);
            //cmd.CommandType = CommandType.StoredProcedure;
            //SqlParameter p1 = cmd.Parameters.Add("@projectID", SqlDbType.Int);
            //p1.Value = projectID;
            //SqlParameter p2 = cmd.Parameters.Add("@Dept", SqlDbType.VarChar);
            //p2.Value = dept;

            //SqlDataAdapter da = new SqlDataAdapter(cmd);
            DataSet ds = new DataSet();

            //cn.Open();
            //da.Fill(ds);
            //cn.Close();

            ds.ReadXml(Server.MapPath("~/Data/ProjectForecast.xml"));
            return ds;
        }


        private void PopulateForecast(DataSet ds)
        {
            grdProjForecast.DataSource = ds.Tables[1];
            grdProjForecast.DataBind();
            FormatProjectForecastGrid();

        }


        protected void grdProjForecast_InitializeRow(object sender, RowEventArgs e)
        {
            //int val = int.Parse(e.Row.Cells.FromKey("Plan1").Text);
            //e.Row.Cells.FromKey("Plan1").Text = val.ToString("C1");
            
        }
    

        protected void grdProjForecast_InitializeLayout(object sender, Infragistics.WebUI.UltraWebGrid.LayoutEventArgs e)
        {
            e.Layout.Bands[0].HeaderLayout.Reset();
            e.Layout.UseFixedHeaders = true;
            // Fix certain header columns

            e.Layout.Bands[0].Columns.FromKey("Description").Header.Fixed = true;
            e.Layout.Bands[0].Columns.FromKey("StoreType").Header.Fixed = true;

        }

        private void FormatProjectForecastGrid()
        {
            string columnCalc;
            string columnFcst;
            int i;
            ColumnHeader ch;
            //Dates dateObj;
            DateTime drp_date;
            string strDate;
            int originx;
            NumberFormatInfo num = new NumberFormatInfo();

            //Hide Certain Columns
            grdProjForecast.Bands[0].Columns.FromKey("prime_key").Hidden = true;           

            //Change Column Headers
            grdProjForecast.Bands[0].Columns.FromKey("StoreType").Header.Caption = "Asst";
            grdProjForecast.Columns.FromKey("StoreType").AllowResize = AllowSizing.Fixed;
            grdProjForecast.Bands[0].Columns.FromKey("StoreType").Width = Unit.Pixel(90);
            grdProjForecast.Bands[0].Columns.FromKey("StoreType").AllowUpdate = AllowUpdate.No;

            grdProjForecast.Bands[0].Columns.FromKey("Description").AllowUpdate = AllowUpdate.No;
            grdProjForecast.Bands[0].Columns.FromKey("Description").Width = Unit.Pixel(140);
            grdProjForecast.Bands[0].Columns.FromKey("StoreType").CellStyle.BackColor = System.Drawing.Color.FromArgb(255, 255, 192);
            grdProjForecast.Bands[0].Columns.FromKey("Description").CellStyle.BackColor = System.Drawing.Color.FromArgb(255, 255, 192);

            for (i = 1; i < 25; i++)
            {
                columnCalc = "calc" + i.ToString();
                grdProjForecast.Columns.FromKey(columnCalc).CellStyle.BackColor = System.Drawing.Color.FromArgb(255, 255, 192);
                grdProjForecast.Columns.FromKey(columnCalc).AllowUpdate = AllowUpdate.No;
                grdProjForecast.Columns.FromKey(columnCalc).Header.Caption = "calc $";
                grdProjForecast.Columns.FromKey(columnCalc).Width = Unit.Pixel(70);
                grdProjForecast.Columns.FromKey(columnCalc).Header.Style.Font.Bold = false;
                grdProjForecast.Columns.FromKey(columnCalc).AllowResize = AllowSizing.Fixed;

                grdProjForecast.Columns.FromKey(columnCalc).Footer.Style.HorizontalAlign = HorizontalAlign.Center;
                grdProjForecast.Columns.FromKey(columnCalc).CellStyle.HorizontalAlign = HorizontalAlign.Right;
                grdProjForecast.Columns.FromKey(columnCalc).Header.Style.Padding.Right = Unit.Pixel(4);
                grdProjForecast.Columns.FromKey(columnCalc).Footer.Style.Padding.Right = Unit.Pixel(4);
                grdProjForecast.Columns.FromKey(columnCalc).CellStyle.Padding.Right = Unit.Pixel(4);
                grdProjForecast.Columns.FromKey(columnCalc).Header.Style.HorizontalAlign = HorizontalAlign.Center;                
                grdProjForecast.Columns.FromKey(columnCalc).Format = "N0";


                columnFcst = "plan" + i.ToString();
                grdProjForecast.Columns.FromKey(columnFcst).CellStyle.BackColor = System.Drawing.Color.FromArgb(255, 255, 255);
                grdProjForecast.Columns.FromKey(columnFcst).Header.Caption = "fcst $";
                grdProjForecast.Columns.FromKey(columnFcst).Width = Unit.Pixel(70);
                grdProjForecast.Columns.FromKey(columnFcst).Header.Style.Font.Bold = false;
                grdProjForecast.Columns.FromKey(columnFcst).AllowResize = AllowSizing.Fixed;
                grdProjForecast.Columns.FromKey(columnFcst).Header.Style.Padding.Right = Unit.Pixel(4);
                grdProjForecast.Columns.FromKey(columnFcst).Footer.Style.Padding.Right = Unit.Pixel(4);
                grdProjForecast.Columns.FromKey(columnFcst).CellStyle.Padding.Right = Unit.Pixel(4);
                grdProjForecast.Columns.FromKey(columnFcst).Footer.Style.HorizontalAlign = HorizontalAlign.Center;
                grdProjForecast.Columns.FromKey(columnFcst).CellStyle.HorizontalAlign = HorizontalAlign.Right;
                grdProjForecast.Columns.FromKey(columnFcst).Header.Style.HorizontalAlign = HorizontalAlign.Center;
                grdProjForecast.Columns.FromKey(columnFcst).Format = "###,###,###,##0";               

            }


            // Create second header band
            foreach (UltraGridColumn c in grdProjForecast.Bands[0].Columns)
            {
                c.Header.RowLayoutColumnInfo.OriginY = 1;
            }

            ch = new ColumnHeader(true);

            //drp_date = DateTime.Today; 
            DataSet drpDS = GetDRPDate("DRP_TODAY_DATE");
            if (drpDS != null && drpDS.Tables[0].Rows.Count > 0 && drpDS.Tables[0].Rows[0]["Date_Date"] != null)
            {
                drp_date = Convert.ToDateTime(drpDS.Tables[0].Rows[0]["Date_Date"].ToString());
            }
            else
            {
                drp_date = DateTime.Today;
            }           
            
            
            originx = 2;

            // Change column headers for sub headers
            for (i = 1; i < 25; i++)
            {
                strDate = String.Format("{0:MMM yyyy}", drp_date);
                ch = new ColumnHeader();
                ch.Caption = strDate;
                ch.RowLayoutColumnInfo.OriginY = 0;
                ch.RowLayoutColumnInfo.OriginX = originx;
                ch.RowLayoutColumnInfo.SpanX = 2;
                ch.Style.HorizontalAlign = HorizontalAlign.Center;
                grdProjForecast.Bands[0].HeaderLayout.Add(ch);

                originx = originx + 2;
                drp_date = drp_date.AddMonths(1);
            }

            ColorCells();


        }

        private void ColorCells()
        {
            int i, x;
            string plan, calc;

            for (i = 0; i < grdProjForecast.Rows.Count; i++)
            {
                for (x = 1; x < 25; x++)
                {
                    plan = "plan" + x.ToString();
                    calc = "calc" + x.ToString();

                    if (Convert.ToInt64(grdProjForecast.Rows[i].Cells.FromKey(plan).Value) < Convert.ToInt64(grdProjForecast.Rows[i].Cells.FromKey(calc).Value))
                        grdProjForecast.Rows[i].Cells.FromKey(plan).Style.BackColor = System.Drawing.Color.FromArgb(255, 192, 255);
                    else if (Convert.ToInt64(grdProjForecast.Rows[i].Cells.FromKey(plan).Value) > Convert.ToInt64(grdProjForecast.Rows[i].Cells.FromKey(calc).Value))
                        grdProjForecast.Rows[i].Cells.FromKey(plan).Style.BackColor = System.Drawing.Color.FromArgb(192, 255, 192);
                    else if (Convert.ToInt64(grdProjForecast.Rows[i].Cells.FromKey(plan).Value) < 0)
                        grdProjForecast.Rows[i].Cells.FromKey(plan).Style.BackColor = System.Drawing.Color.Red;
                }
            }
        }
    
        private DataTable GetProjPlanningInfo(DataTable projPlanDataTable)
        {

            int i, x; string plan;
            string planValue = string.Empty;
            int planV = 0;

            for (i = 0; i < grdProjForecast.Rows.Count; i++)
            {
                projPlanDataTable.DefaultView.RowFilter = "prime_key='" + grdProjForecast.Rows[i].Cells.FromKey("prime_key").Value.ToString() + "'";
                foreach (DataRowView dr in projPlanDataTable.DefaultView)
                {
                    for (x = 1; x < 25; x++)
                    {
                        plan = "plan" + x.ToString();
                        planValue = (grdProjForecast.Rows[i].Cells.FromKey(plan).Value != null ? grdProjForecast.Rows[i].Cells.FromKey(plan).Value.ToString() : string.Empty);
                        if (dr[plan].ToString() != planValue)
                        {
                            int.TryParse(planValue, out planV);
                            dr[plan] = planV;
                        }
                    }
                }
            }

            return projPlanDataTable;
            
        }

        private DataSet GetDRPDate(string type)
        {
            //SqlConnection cn = new SqlConnection("Data Source=PY1DBMAPd01;Integrated Security=True;Initial Catalog=DMD_MGMT");
            //SqlCommand cmd = new SqlCommand("CR_GetDateByName", cn);
            //cmd.CommandType = CommandType.StoredProcedure;
            //SqlParameter p1 = cmd.Parameters.Add("@DateName", SqlDbType.VarChar);
            //p1.Value = type;

            //SqlDataAdapter da = new SqlDataAdapter(cmd);
            DataSet ds = new DataSet();

            //cn.Open();
            //da.Fill(ds);
            //cn.Close();

            ds.ReadXml(Server.MapPath("~/Data/DRP_Date.xml"));
            return ds;
       }
    }
}
